*****************************************
*                                       *
* << Gpu / Dsp unpack rout : >>         *
* -----------------------------         *
*                                       *
* << Original Code : Ray (TSCC) >>      *
*                                       *
* << Gpu adaptation : GT Turbo >>       *
*                                       *
*                                       *
*                         Jagware 2005  *
*                                       *
*                                       *
* Never kills any Nops, or......        *
*                                       *
*****************************************

	.gpu

A_zero	.equr	r0
A_one	.equr	r1
A_two	.equr	r2

D_zero	.equr	r3
D_one	.equr	r4
D_two	.equr	r5
D_three	.equr	r6
D_four	.equr	r7
Reg_temp	.equr	r8

LT	.ccdef	%11000

	.org	$0	; Relatif PC Code ;)

; *****************************************************************
; Auto-reloc

Start:
	move	pc,r14

; *****************************************************************

Modif:
	movei	#loadtag-Start,r20
	movei	#literal-Start,r21
	movei	#search-Start,r22
	movei	#break-Start,r23
	movei	#$ff0f,r24		; And masque 
	movei	#Params-Start,r25

	movei	#$f02114,r26		; Gpu Control reg

	movei	#$f03fff,r27
	
	cmp	r27,r14		; Dsp or Gpu ram ?
	jr	LT,In_the_gpu_ram
	nop
	movei	#$f1a114,r26
In_the_gpu_ram:

	add	r14,r20
	add	r14,r21
	add	r14,r25
	add	r14,r22
	add	r14,r23

; *****************************************************************

	load	(r25),A_zero
	addq	#4,r25
	load	(r25),A_one

; *****************************************************************

	addq	#4,A_zero
	jump	(r20)	; loadtag=r20
	nop

; *****************************************************************

literal:
	REPT	8
	loadb	(A_zero),Reg_temp
	storeb	Reg_temp,(A_one)
	addq	#1,A_zero
	addq	#1,A_one
	nop
	ENDR

; *****************************************************************

loadtag:
	loadb	(A_zero),D_zero
	addq	#1,A_zero
	cmpq	#0,D_zero
	jump	EQ,(r21)	; literal=r21
	
; *****************************************************************

	moveq	#8-1,D_one

	nop

search:
	shlq	#1,D_zero
	nop
	btst	#8,D_zero	
	jr	NE,compressed
	nop	

	loadb	(A_zero),Reg_temp
	storeb	Reg_temp,(A_one)

	subq	#1,D_one

	addqt	#1,A_zero
	addqt	#1,A_one

	jr	PL,search
	nop
	jump	(r20)	; loadtag=r20
	nop

; *****************************************************************

compressed:
	loadb	(A_zero),D_two

	cmpq	#0,D_two
	jump	EQ,(r23)	; break=r23

	moveq	#$f,D_three	
	addq	#1,A_zero
	and	D_two,D_three

	shlq	#4,D_two	
	loadb	(A_zero),D_four
	and	r24,D_two
	addq	#1,A_zero
	or	D_four,D_two

	move	A_one,A_two	
	subq	#1,D_three
	sub	D_two,A_two

Boucle_main:
	loadb	(A_two),Reg_temp
	storeb	Reg_temp,(A_one)
	addq	#1,A_two
	addq	#1,A_one

	subq	#1,D_three
	jr	PL,Boucle_main		
	nop

	loadb	(A_two),Reg_temp
	storeb	Reg_temp,(A_one)
	addq	#1,A_two
	addq	#1,A_one

	loadb	(A_two),Reg_temp
	storeb	Reg_temp,(A_one)
	addq	#1,A_two
	addq	#1,A_one

	subq	#1,D_one
	jump	PL,(r22)	; search=r22
	nop
	
	jump	(r20)	; loadtag=r20		
	nop

; *****************************************************************
;

break:

	moveq	#0,r0	; pour stopper le gpu
	nop
	store	r0,(r26)	; stop le gpu
	nop
	nop
	nop
Params:

	.END


